using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using System.Collections;

namespace PowerAllocation
{
    
    public partial class PwdAllocation : Form
    {
        int ErrAt;
        int ReSend = 0;
        string Temp,MsgStatus;
        int cntt, tot, a, FileInfoCount, intNode,counter;
        byte[] NewFileArray;
        int PortNumber = 815;

       ArrayList cmbList = new ArrayList ();
        string[] lst2cmb = { "1-2","1-4","2-1","2-3","2-5","3-2","4-1","4-5","4-7","3-2","3-6","5-2","5-4"
                                ,"5-6","5-8","6-5","6-3","7-4","7-8","8-7","8-5","8-9","9-6","9-8"};

        string[] lst3cmd ={"1-2-3","1-2-4","1-4-5","1-4-7","2-1-4","2-3-6","2-5-4","2-5-6","3-2-1","3-6-5",
                                "3-6-9","4-1-2","4-5-6","4-5-2","4-7-8","5-2-1","5-2-3","5-4-1","5-4-7","5-6-3","5-6-9",
                                "5-8-7","5-8-9","6-3-2","6-5-2","6-5-4","6-9-8","7-4-1","7-4-5","7-8-5","7-8-9","8-5-4",
                                "8-5-2","8-5-6","8-7-4","8-9-6","9-6-3","9-6-5","9-8-5","9-8-7"};
        bool isResend = false;
        byte[]TrxData;
        TcpClient tcpClient;
        OpenFileDialog OpenFile = new OpenFileDialog();
        FileStream fstFile;
        NetworkStream strclientRemote;
        private NetworkStream strRemote;
        private Thread thrDownload;
        private Stream strLocal;
        private TcpListener tlsServer;
        private delegate void UpdateStatusCallback(string StatusMessage);
        private delegate void UpdateProgressCallback(Int64 BytesRead, Int64 TotalBytes);
        private static int PercentProgress;

        public PwdAllocation()
        {
            InitializeComponent();
        }

        private void PwdAllocation_Load(object sender, EventArgs e)
        {
            GetCom();
           
            cmbTx.DropDownStyle = ComboBoxStyle.DropDownList;
            cmbReciver.DropDownStyle = ComboBoxStyle.DropDownList;
            cmbTx.SelectedIndex = 0;
            //cmbReciver.SelectedIndex =0;
            SetVisibility_Browse(false);
            thrDownload = new Thread(StartReceiving);
            thrDownload.Start();
        }

        private void StartReceiving()
        {
            try
            {
                string hstServer = Dns.GetHostName();

                IPAddress ipaLocal = Dns.GetHostEntry(hstServer).AddressList[0];

                if (tlsServer == null)
                {
                    tlsServer = new TcpListener(ipaLocal,PortNumber);
                }
                tlsServer.Start();

                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "Server : The server has started.\n\n" });

                TcpClient tclServer = tlsServer.AcceptTcpClient();

                string strFileName = "C:\\";

                strRemote = tclServer.GetStream();

                int bytesSize = 0;

                byte[] downBuffer = new byte[2048];

                bytesSize = strRemote.Read(downBuffer, 0, 2048);

                string FileName = System.Text.Encoding.ASCII.GetString(downBuffer, 0, bytesSize);

                strLocal = new FileStream(strFileName + FileName, FileMode.Create, FileAccess.Write, FileShare.ReadWrite);

                downBuffer = new byte[2048];

                bytesSize = strRemote.Read(downBuffer, 0, 2048);

                long FileSize = Convert.ToInt64(System.Text.Encoding.ASCII.GetString(downBuffer, 0, bytesSize));

                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "Server : Receiving file " + FileName + " (" + FileSize + " bytes)\r\n" });

                downBuffer = new byte[2048];

                while ((bytesSize = strRemote.Read(downBuffer, 0, downBuffer.Length)) > 0)
                {
                    strLocal.Write(downBuffer, 0, bytesSize);

                    this.Invoke(new UpdateProgressCallback(this.UpdateProgress), new object[] { strLocal.Length, FileSize });
                }

            }
            catch (Exception)
            {
                //MessageBox.Show(ex.Message);
            }
            finally
            {
                //this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "Server : The file was received. Closing streams.\r\n" });
                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "" });
                try
                {
                    strLocal.Close();
                    strRemote.Close();
                }
                catch (Exception)
                {
                    //  MessageBox.Show(ex.Message);
                }
                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "" });
                //StartReceiving();
            }
        }

        private void UpdateStatus(string StatusMessage)
        {
            //txtMsg.Text += StatusMessage;
        }
        private void UpdateProgress(Int64 BytesRead, Int64 TotalBytes)
        {
            if (TotalBytes > 0)
            {
                PercentProgress = Convert.ToInt32((BytesRead * 100) / TotalBytes);
                //progress.Value = PercentProgress;
            }
        }



        private void GetCom()
        {

            for (int i = 0; i < lst2cmb.Length - 1; i++)
            {
                cmbList.Add(lst2cmb[i].ToString());
                for (int j=0 ;j<lst3cmd.Length-1 ;j++)
                {
                    cmbList.Add(lst3cmd[j].ToString());
                    
                        cmbList.Add(lst2cmb[i].ToString() + "-" + lst3cmd[j].ToString());
                }
            }
        }





                

              

        private int ErrMsg(int len, string str)
        {
            cntt = 0;
            for (int i = 0; i < len; i++)
            {
                if (i != len)
                {
                    a = Convert.ToInt32(str.Substring(i, 1));
                    tot = cntt + a;
                    cntt = tot;
                }
            }
            if (Convert.ToString(cntt).Length > 1)
                tot = Convert.ToInt32(Convert.ToString(cntt).Substring(0, 1)) + Convert.ToInt32(Convert.ToString(cntt).Substring(1, 1));
            else
                tot = cntt;

            return tot;
        }

               

        private void ApplyColor(string BackColor ,bool isReSet,string node)
        {
            try
            {
                foreach (Control ctrl in grpPowerAllocation.Controls)
                {
                    if (!isReSet)
                    {

                        if (node == "0")
                        {
                            if (ctrl.Name == "pnlTxReciver" + cmbReciver.SelectedIndex)
                            {
                                ctrl.BackColor = System.Drawing.ColorTranslator.FromHtml(BackColor);
                            }
                        }
                        else if (ctrl.Name == "pnlTxReciver" + node)
                        {
                            ctrl.BackColor = System.Drawing.ColorTranslator.FromHtml(BackColor);
                        }
                       
                    }
                    else
                    {
                        if (ctrl.Name .Contains ("pnlTxReciver" ))
                        {
                            ctrl.BackColor = System.Drawing.ColorTranslator.FromHtml(BackColor);
                        }
                    }

                }
            }
            catch
            {

            }
        }


        private void cmbTx_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (cmbTx.SelectedIndex == 1)
            {
                SetVisibility_Browse(false);
                btnBrowse_1.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 2)
            {
                SetVisibility_Browse(false);
                btnBrowse_2.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 3)
            {
                SetVisibility_Browse(false);
                btnBrowse_3.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 4)
            {
                SetVisibility_Browse(false);
                btnBrowse_4.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 5)
            {
                SetVisibility_Browse(false);
                btnBrowse_5.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 6)
            {
                SetVisibility_Browse(false);
                btnBrowse_6.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 7)
            {
                SetVisibility_Browse(false);
                btnBrowse_7.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 8)
            {
                SetVisibility_Browse(false);
                btnBrowse_8.Visible = true;
            }
            else if (cmbTx.SelectedIndex == 9)
            {
                SetVisibility_Browse(false);
                btnBrowse_9.Visible = true;
            }
            
        }

        private void SetVisibility_Browse(bool visibile)
        {
            btnBrowse_1.Visible = visibile;
            btnBrowse_2.Visible = visibile;
            btnBrowse_3.Visible = visibile;
            btnBrowse_4.Visible = visibile;
            btnBrowse_5.Visible = visibile;
            btnBrowse_6.Visible = visibile;
            btnBrowse_7.Visible = visibile;
            btnBrowse_8.Visible = visibile;
            btnBrowse_9.Visible = visibile;
        }

        
        private void btnBrowse_Click(object sender, EventArgs e)
        {
            ofdOpenFile.ShowDialog();

        }


        private void cmbReciver_SelectedIndexChanged(object sender, EventArgs e)
        {
            //ApplyColor("#CDAF95",true,"0");
            txtIPAddress.Enabled = true;
        }


        private void btn_Connect_Click(object sender, EventArgs e)
        {
            ConnectToServer(txtIPAddress.Text, PortNumber);
        }

        private void ConnectToServer(string ServerIP, int ServerPort)
        {
            tcpClient = new TcpClient();
            try
            {
                tcpClient.Connect(ServerIP, ServerPort);
                MessageBox.Show("Successfully connected to server");
            }
            catch (Exception exMessage)
            {
                MessageBox.Show(exMessage.Message);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //try
            //{
            //    if (tcpClient.Connected == false)
            //    {
            //        ConnectToServer(txtIPAddress.Text,PortNumber);
            //    }
            //    if (OpenFile.ShowDialog() == DialogResult.OK)
            //    {
                    try
                    {
                        this.Refresh();

                        // txtMsg.Text += "Client : Sending file information\r\n";
                        strclientRemote = tcpClient.GetStream();
                        byte[] byteSend = new byte[tcpClient.ReceiveBufferSize];
                        fstFile = new FileStream(ofdOpenFile.FileName, FileMode.Open, FileAccess.Read);
                        BinaryReader binFile = new BinaryReader(fstFile);
                        FileInfo fInfo = new FileInfo(ofdOpenFile.FileName);
                        Thread.Sleep(100);
                        string FileName = fInfo.Name;
                        byte[] ByteFileName = new byte[2048];
                        ByteFileName = System.Text.Encoding.ASCII.GetBytes(FileName.ToCharArray());
                        strclientRemote.Write(ByteFileName, 0, ByteFileName.Length);

                        long FileSize = fInfo.Length;
                        byte[] ByteFileSize = new byte[2048];
                        ByteFileSize = System.Text.Encoding.ASCII.GetBytes(FileSize.ToString().ToCharArray());
                        strclientRemote.Write(ByteFileSize, 0, ByteFileSize.Length);

                        MessageBox.Show("Sending the file " + FileName + " (" + FileSize + " bytes)\r\n");
                        Thread.Sleep(100);
                        int bytesSize = 0;
                        byte[] downBuffer = new byte[2048];
                        Thread.Sleep(1000);
                        while ((bytesSize = fstFile.Read(downBuffer, 0, downBuffer.Length)) > 0)
                        {
                            strclientRemote.Write(downBuffer, 0, bytesSize);
                        }

                        //txtMsg.Text += "Client : File sent. Closing streams and connections.\r\n";
                        MessageBox.Show("File sent");
                        tcpClient.Close();
                        strclientRemote.Close();
                        fstFile.Close();
                        //txtMsg.Text += "Client : Streams and connections are now closed.\r\n";
                        btnBrowse_1.Visible = false;
                        btnBrowse_2.Visible = false;
                        btnBrowse_3.Visible = false;
                        btnBrowse_4.Visible = false;
                        btnBrowse_5.Visible = false;
                        btnBrowse_6.Visible = false;
                        btnBrowse_7.Visible = false;
                        btnBrowse_8.Visible = false;
                        btnBrowse_9.Visible = false;
                    }
                    catch
                    {
                        MessageBox.Show("Try Again");
                    }
                }
            //}
            //catch (Exception ex)
            //{
            //    MessageBox.Show(ex.Message);
            //}


        //}

        private void btn_Disconnect_Click(object sender, EventArgs e)
        {
            try
            {
                if (tcpClient != null)
                {
                    tcpClient.Close();
                    strclientRemote.Close();
                    fstFile.Close();
                }
                if (strRemote != null)
                {
                    strRemote.Close();
                    strLocal.Close();
                }
                txtIPAddress.Enabled = false;
                cmbTx.SelectedIndex = 0;
                cmbReciver.Items.Clear();
                ApplyColor("#FFFFFF", true, "0");
                MessageBox.Show("Disconnected from server");

            }
            catch
            {
                MessageBox.Show("Disconnected from server");
            }
        }

        private void btn_Exit_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}